export const DefaultHighlightMark = '/*!*/';
export function parse(code, highlightMark = DefaultHighlightMark) {
    const lines = code.split('\n');
    const highlights = [];
    const linesParsed = lines.map((line, index) => {
        if (line.startsWith(highlightMark)) {
            highlights[index] = true;
            return line.substr(highlightMark.length);
        }
        else {
            highlights[index] = false;
            return line;
        }
    });
    const codeParsed = linesParsed.join('\n');
    return [codeParsed, linesParsed, highlights];
}
//# sourceMappingURL=parse.js.map