declare type GithubBtnUserActions = 'Follow' | 'Sponsor';
declare type GithubBtnRepoUncountableActions = 'UseThisTemplate' | 'Download';
declare type GithubBtnRepoCountableActions = 'Watch' | 'Star' | 'Fork' | 'Issue';
export declare type GithubBtnActions = GithubBtnUserActions | GithubBtnRepoUncountableActions | GithubBtnRepoCountableActions;
export declare type GithubBtnColorMode = 'Light' | 'Dark';
interface GithubBtnOptionsBase {
    action: string;
    user: string;
    link?: string;
    label?: string;
    ariaLabel?: string;
    icon?: string;
    standardIcon?: boolean | string;
    large?: boolean | string;
    color?: GithubBtnColorMode;
    colorLight?: GithubBtnColorMode;
    colorDark?: GithubBtnColorMode;
}
interface GithubBtnUserOptions extends GithubBtnOptionsBase {
    action: GithubBtnUserActions;
}
interface GithubBtnRepoOptions extends GithubBtnOptionsBase {
    repo: string;
}
interface GithubBtnRepoUncountableOptions extends GithubBtnRepoOptions {
    action: GithubBtnRepoUncountableActions;
}
interface GithubBtnRepoCountableOptions extends GithubBtnRepoOptions {
    action: GithubBtnRepoCountableActions;
    count?: boolean | string;
}
export declare function isCountable(options: GithubBtnOptionsBase): options is GithubBtnRepoCountableOptions;
export declare type GithubBtnOptions = GithubBtnUserOptions | GithubBtnRepoCountableOptions | GithubBtnRepoUncountableOptions;
export {};
